
#set system name to generic to enable cross compiling
set(CMAKE_SYSTEM_NAME Generic)
#set the name of the desired platform
set(PLATFORM_NAME "port_demo")

set(DEVICE_FOLDER ./LPC54628)
set(POWOERLIB_FOLDER ${DEVICE_FOLDER}/mcuxpresso)
set(LINKER_FILE LPC54628_Project_test_Debug.ld)
set(OUTPUT_FILE LPC54628_Project_test_my.axf)

#set(CMAKE_FIND_ROOT_PATH ${BINUTILS_PATH})
#set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM NEVER)
#set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY ONLY)
#set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE ONLY)

#set the compiler
set(CMAKE_C_COMPILER   /opt/mcuxpresso-ide/ide/plugins/com.nxp.mcuxpresso.tools.linux_11.7.1.202301190959/tools/bin/arm-none-eabi-gcc)
set(CMAKE_CXX_COMPILER /opt/mcuxpresso-ide/ide/plugins/com.nxp.mcuxpresso.tools.linux_11.7.1.202301190959/tools/bin/arm-none-eabi-g++)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -D__REDLIB__ -DCPU_LPC54628J512ET180 -DCPU_LPC54628J512ET180_cm4 -DSDK_OS_BAREMETAL -DSERIAL_PORT_TYPE_UART=1 -DSDK_DEBUGCONSOLE=0 -DCR_INTEGER_PRINTF -DPRINTF_FLOAT_ENABLE=0 -D__MCUXPRESSO -D__USE_CMSIS -DDEBUG -O0 -fno-common -g3 -Wall -c -ffunction-sections -fdata-sections -ffreestanding -fno-builtin -fmerge-constants -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -D__REDLIB__ -fstack-usage -specs=redlib.specs -MMD -MP -MF"$(@:%.o=%.d)" -MT"$(@:%.o=%.o)" -MT"$(@:%.o=%.d)" -o "$@" "$<" " CACHE STRING "Cortex M4 C Flags")
#-specs=nano.specs new lib muss noch hinein gibt ein fehler


#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__NEWLIB__ -DCPU_LPC54628J512ET180 -DCPU_LPC54628J512ET180_cm4 -DSDK_OS_BAREMETAL -DSERIAL_PORT_TYPE_UART=1 -DSDK_DEBUGCONSOLE=0 -D__MCUXPRESSO -D__USE_CMSIS -DDEBUG -O0 -fno-common -g3 -Wall -c -ffunction-sections -fdata-sections -ffreestanding -fno-builtin -fmerge-constants")


#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DDEBUG -D__CODE_RED -DCORE_M4 -D__GENERIC_M4__ -D__REDLIB__ -O0 -fno-common -g3 -Wall -c -fmessage-length=0 -fno-builtin -ffunction-sections -fdata-sections -fsingle-precision-constant -fmerge-constants -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=softfp -mthumb -D__REDLIB__ -fstack-usage ")

set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -nostdlib -L${POWOERLIB_FOLDER} -Xlinker -Map=${PROJECT_NAME}.map -Xlinker --gc-sections -Xlinker -print-memory-usage -Xlinker --sort-section=alignment -Xlinker --cref -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -T${LINKER_FILE} -o${OUTPUT_FILE} $(OBJS) $(USER_OBJS) $(LIBS) -lpower_hardabi" CACHE STRING "Cortex M4 Linker Flags")

